#include <stdio.h>
#include <termios.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#undef max
#define max(x,y) ((x) > (y) ? (x) : (y))

int main(void)
{
	int	fd; 
	int retval;
	fd_set	rfds;
	struct termios	termios_p;
	struct timeval tv;
	int n;	

	n=0;
	FD_ZERO(&rfds);
	FD_SET(0, &rfds);
	n = max(n,0);
	/* Ouverture de la liaison serie (open serial port) */
	if ( (fd=open("/dev/ttyS0",O_RDWR | O_NOCTTY )) <0 ) {
		perror("open");
		exit(-1);
	}
	FD_SET(fd, &rfds);
	n = max(n,fd);
	/* Lecture des parametres courants (get informations) */
	tcgetattr(fd,&termios_p);
	/* On ignore les BREAK et les caracteres avec erreurs de parite */
	termios_p.c_iflag = IGNBRK | IGNPAR;
	/* Pas de mode de sortie particulier */
	termios_p.c_oflag = 0;
	/* Liaison a 9600 bps avec 7 bits de donnees et une parite paire */
	termios_p.c_cflag = B9600 | CS8 | CLOCAL | CREAD ;
	/* Mode non-canonique sans  echo */
	termios_p.c_lflag = 0;
	/* Caracteres immediatement disponibles */
	termios_p.c_cc[VMIN] = 1;
	termios_p.c_cc[VTIME] = 0;
	/* Sauvegarde des nouveaux parametres */
	tcsetattr(fd,TCSANOW,&termios_p);
	
	/* paramtrage 5s (after 10s select exit)*/
	tv.tv_sec = 10;
	tv.tv_usec = 0;

	/* Affichage sur le terminal */
	printf("Tapez Ctrl-C pour quitter\n");
	
	if (tcflush(fd, TCIOFLUSH) <0 )
	{	
		printf("Can blank buffer\n");
	}	
	/* Boucle de lecture (reading loop)*/
	while(1)
	{
		
		FD_SET(0, &rfds);
		FD_SET(fd, &rfds);
		retval =select(n+1,&rfds,NULL,NULL,&tv);
		printf("retval=%d\n",retval);
		if (retval)
		{
			if (FD_ISSET(0, &rfds)) /*will be true. */
			{
				char buff;
				read(0,&buff,1);
				printf("%c\n",buff);
			}
			if (FD_ISSET(fd, &rfds))
			{
				char buff;
				read(fd,&buff,1);
				printf("%c\n",buff);
			}
		}
		else
		{
			printf("10 passed and nothing arrived\n");
			close(fd);
			exit(0);
		}

	}	
	/* Bye... */
	close(fd);
	exit(0);

}
